/* 2006.10.15
****************************************
**  Copyright  (C)  W.ch  1999-2006   **
**  Web:  http://www.wch.cn  **
****************************************
**  Mp3 Module Test      @CH375  **
**  TC2.0@PC, KC7.0@MCS51             **
****************************************
*/

#include <reg52.h>
#include <string.h>
#include <stdio.h>

#define MAX_PATH_LEN			64		// ·,бָܷСԼ·00H,CH375ģֵֵ֧62,Сֵ1
#include "CH375HM.H"

/*	óUе/C51/CH375HFT.MP3ļ
	1.ҵ,򲥷,,ȡUеһƵļ,,öһ
	2.Ҳ,ȡUеһƵļ, ,öһ
*/
/*  ·ӷʽ,ֻҪ3,ʹôͬ
		PC			Ƭ		ģ
		RXD		=	TXD		=	RXD
		--		=	RXD		=	TXD
		GND	    =	GND		=	GND
*/
//  ˵
// 	1. ͨPCʾУPCʾϢʱ,ģҲյݣƵ봮ж,յݡ
//  2. ģϵ
//  3. 24M,ʣ9600bps
//  4. PC,źPC_DEMO

//	#define PC_DEMO	1					// PC

#define CMD_RootMp3Inf          0xE0	// öUƵļ
#define CMD_Decode				0xE1	// ŵǰƵļ
#define CMD_Pause				0xE2    // ͣ
#define CMD_Stop				0xE3	// ֹͣ
#define CMD_VolumeH	     		0xE4	// 
#define CMD_VolumeL		    	0xE5	// С
#define CMD_EnumUpMp3      	    0xE6	// öһļ
#define CMD_EnumDownMp3      	0xE7	// öһļ
#define CMD_EnumCurrent			0xE8	// öٵһƵļ
#define CMD_AutoDec		    	0xEF	// Զ

CMD_PARAM	idata	mCmdParam;			// Ĭ¸ýṹռ60ֽڵRAM,޸MAX_PATH_LEN,޸Ϊ32ʱ,ֻռ32ֽڵRAM
sbit	LED_OUT		=	P1^4;			// P1.4 ͵ƽLEDʾ,ڼʾĽ

/* ԺΪλʱ,24MHzʱ */
void	mDelaymS( unsigned char delay )
{
	unsigned char	i, j, c;
	for ( i = delay; i != 0; i -- )
	{
		for ( j = 200; j != 0; j -- ) c += 3;  /* 24MHzʱʱ500uS */
		for ( j = 200; j != 0; j -- ) c += 3;  /* 24MHzʱʱ500uS */
	}
}

/* һֽݸCH375ģ */
void mSendByte( unsigned char c )
{
	TI = 0;
	SBUF = c;
	while ( TI == 0 );
}

/* CH375ģһֽ */
unsigned char mRecvByte( )
{
	unsigned char	c;
	
	while ( RI == 0 );
	c = SBUF;
	RI = 0;
	return c;
}

/* ִ */
unsigned char	ExecCommand( unsigned char cmd, unsigned char len )
/* ,ز״̬,ͷزCMD_PARAMṹ */
{
	unsigned char i, j, status;
	mSendByte( SER_SYNC_CODE1 );  /* ʹ֪ͬͨģ,˵뿪ʼ,ʼִ */
	mSendByte( SER_SYNC_CODE2 );  /* ͬSTA#½ */
/* ͬӦ,,ôʱ䲻ܳ20mS,Ч */
	RI = 0;
	mSendByte( cmd );  /* д */
	mSendByte( len );  /* дĳ */
	if ( len ) {  /* в */
		for ( i = 0; i != len; i ++ ) mSendByte( mCmdParam.Other.mBuffer[ i ] );  /* д */
	}
	while ( 1 ) {  /* ݴ,ֱɲ˳ */
		status = mRecvByte( );  /* ȴģɲز״̬ */
		if ( status == ERR_SUCCESS ) {  /* ɹ */
			i = mRecvByte( );  /* ؽݵĳ */
			if ( i ) {  /* н */
				j = 0;
				do {  /* ʹdo+whileṹΪЧʸfor */
					mCmdParam.Other.mBuffer[ j ] = mRecvByte( );  /* սݲ浽ṹ */
					j ++;
				} while ( -- i );
			}
			break;  /* ɹ */
		}
		else if ( status == USB_INT_DISK_READ || status == USB_INT_DISK_WRITE || status == USB_INT_DISK_RETRY ) {  /* ڴU̶ݿ,ݶ,Uдݿ,д,дݿʧ */
			break;  /* ֻʹֽΪλļдӳ,²յ״̬,ʧܷ */
		}
		else {  /* ʧ */
			if ( status == ERR_DISK_DISCON || status == ERR_USB_CONNECT )
				mDelaymS( 100 );  /* U̸ոӻ߶Ͽ,Ӧʱʮٲ */
			break;  /* ʧܷ */
		}
	}
	return( status );
}

/* ״̬,ʾ벢ͣ */
void	mStopIfError( unsigned char iError )
{
	unsigned char	led;
	if ( iError == ERR_SUCCESS ) return;  /* ɹ */
#ifdef PC_DEMO
	printf( "\nPC_DEMO: Error: %02x\n", (unsigned short)iError );  /* ʾ */
#endif
	led = 0;
	while(1)
	{
		LED_OUT = led & 1;  /* LED˸ */
		mDelaymS( 100 );
		led ^= 1;
	}
}

void main(void)
{
	unsigned char i;
	unsigned char mCmdCode;								// 
	

	LED_OUT = 0; 										// LEDһʾ
	mDelaymS(100);
	LED_OUT = 1;
// Mp3ģͨѶĴ
	SCON = 0x50;
	PCON = 0x80;
	TMOD = 0x21;
	TH1 = 0xF3;		// 24MHz, 9600bps
	TR1 = 1;
	TI = 1;

#ifdef PC_DEMO
	printf("\nPC_DEMO: Start Demo\n");	
#endif
	while( 1 )												// ʹòѯʽUǷ
	{	
		i = ExecCommand( CMD_QueryStatus, 0 );				// ѯǰģ״̬
		mStopIfError( i );
		if ( mCmdParam.Status.mDiskStatus >= DISK_CONNECT )
			break;  										// UѾ
		mDelaymS( 100 );									// ڴдUʱٲѯ,ûбҪһֱͣزѯ,õƬ,û¿ʱȴһٲѯ
	}
	mDelaymS( 200 );										// ʱ,ѡ,еUSB洢Ҫʮʱ
	LED_OUT = 0;

	for( i = 0; i < 5; i ++ )								// UǷ׼,U̲Ҫһ,ĳЩU̱Ҫִһܹ
	{
		mDelaymS( 100 );
#ifdef PC_DEMO
		printf("\nPC_DEMO: Ready?\n");
#endif
		if ( ExecCommand( CMD_DiskReady, 0 ) == ERR_SUCCESS )
		{
#ifdef PC_DEMO
			printf("\nPC_DEMO: Disk is Ready!\n");
#endif
			break;											// ѯǷ׼
		}
	}
#ifdef PC_DEMO
	printf("\nPC_DEMO: Search File:/C51/CH375HFT.MP3\n");
#endif
	strcpy(mCmdParam.Open.mPathName, "/C51/CH375HFT.MP3");			// ļ,ļC51Ŀ¼
	i = ExecCommand(CMD_FileOpen,MAX_PATH_LEN);				// ļ,Ϊֵ,ʡټ
	if ( i == ERR_MISS_DIR || i == ERR_MISS_FILE )  /* ERR_MISS_DIR˵ûҵC51Ŀ¼,ERR_MISS_FILE˵ûҵļ */
	{
#ifdef PC_DEMO
		printf("\nPC_DEMO: Can't Find File:/C51/CH375HFT.MP3\n" );
#endif
EnumAllFile:
		mCmdCode = CMD_EnumCurrent;
		while(1)
		{
			switch(mCmdCode)
			{
				case CMD_EnumCurrent:
				{
					i = ExecCommand(CMD_EnumCurrent,0);
					mStopIfError(i);
#ifdef PC_DEMO
					printf("\nPC_DEMO: Current File Is:%s\n",mCmdParam.Other.mBuffer);
#endif
					mCmdCode = CMD_Decode;
				}break;
				case CMD_EnumDownMp3:
				{
#ifdef PC_DEMO
					printf("\nPC_DEMO: Enum Next Files:...\n");
#endif
					i = ExecCommand( CMD_EnumDownMp3,0 );
					mStopIfError( i );
#ifdef PC_DEMO
					printf("\nPC_DEMO: Current File Is:%s\n",mCmdParam.Other.mBuffer);
#endif
					mCmdCode = CMD_Decode;
				}break;
				case CMD_Decode:
				{
#ifdef PC_DEMO
					printf("\nPC_DEMO: Paly...\n");
#endif
					i = ExecCommand(CMD_Decode,0);
					mStopIfError(i);
CONTINUE0:			i = mRecvByte();
					if(i == 0xF2) mCmdCode = CMD_EnumDownMp3;
					else goto CONTINUE0;
				}break;
			}
		}
	}
	else
	{
		mStopIfError(i);
		i = ExecCommand(CMD_Decode,0);
		mStopIfError(i);
#ifdef PC_DEMO
		printf("\nPC_DEMO: Play:/C51/CH375HFT.MP3\n");
#endif
CONTINUE1:
		i = mRecvByte();
		if(i == 0xF2) goto EnumAllFile;
		else goto CONTINUE1;
	}
}
